@book{non-functional,
  title={Requirements Engineering: A good Practice Guide},
  author={Sawyer, Pete and Sommerville, Ian},
  year={1997},
  publisher={John Wiley \& Sons},
  isbn={0471974447}
}

@MISC{TRACS,
  title={Online TRACS: Understanding the Notional Machine},
  author={Georgieva, Gabriela},
  year={2018}
}

@book{branching,
 title={Beginning Git and GitHub},
 author={Tsitoara, Mariot},
 year={2020},
 publisher={Apress},
 isbn={978-1-4842-5312-0},
 doi={10.1007/978-1-4842-5313-7},
 url={https://doi.org/10.1007/978-1-4842-5313-7}
}

@book{sprints,
  title={Agile Software Development with HP Agile Manager},
  author={Tal, Liran},
  year={2015},
  publisher={Apress},
  isbn={978-1-4842-1035-2},
  doi={/10.1007/978-1-4842-1034-5},
  url={https://doi-org.ezproxy.lib.gla.ac.uk/10.1007/978-1-4842-1034-5}
}

@book{reactPro,
  title={Pro React 16},
  author={Freeman, Adam},
  year={2019},
  publisher={Apress},
  isbn={978-1-4842-4450-0},
  doi={10.1007/978-1-4842-4451-7},
  url={https://doi.org/10.1007/978-1-4842-4451-7}
}

@MISC{functionSwitch,
  title={Binding functions in React},
  author={Arnold, Jason},
  year={2017},
  month={jun},
  day={15},
  howpublished={\url{https://codeburst.io/binding-functions-in-react-b168d2d006cb}}
}

@MISC{router,
  title={React Router: Declarative Routing for React.js},
  author={{\relax React Training}},
  year={2020},
  howpublished={\url{https://reacttraining.com/react-router/web/guides/quick-start}}
}

@MISC{unittests,
  title={Testing Library},
  author={{\relax Testing Library}},
  year={2019},
  howpublished={\url{https://testing-library.com/}}
}

@article{SUS,
  title={The System Usability Scale: Beyond Standard Usability Testing},
  author={Grier, Rebecca A. and Bangor, Aaron and Kortum, Phillip and Peres, S. Cammille},
  year={2013}
}

@article{notionalMachineDefinition,
  title={Some difficulties of learning to program},
  author={du Boulay, Benedict},
  year={1986},
  publisher={Journal of Educational Computing Research},
  volume={2}
}

@article{notionalMachineExplanation,
  title={The State of Play: a Notional Machine for Learning Programming},
  author={Berry, Michael and Kölling, Michael},
  year={2014},
  publisher={ITiCSE},
  doi={10.1145/2591708.2591721},
  url={http://dx.doi.org/10.1145/2591708.2591721.}
}

@article{notionalMachineExplanation2,
  title={Notional Machines and Introductory Programming Education},
  author={Sorva, Juha},
  year={2013},
  publisher={ACM},
  doi={10.1145/2483710.2483713},
  url={http://dx.doi.org/10.1145/2483710.2483713}
}

@article{nmPrinciples,
  title={The black box inside the glass box: presenting computing concepts to novices},
  author={du Boulay, Benedict and O'Shea, Tim and Monk, John},
  year={1999},
  publisher={International Journal of Human-Computer Studies},
  number={ijhc.1981.0309}
}

@article{PLANC,
  title={An evaluation of a professional learning network for computer science teachers},
  author={Cutts, Quintin and Robertson, Judy and Donaldson, Peter and O'Donnell, Laurie},
  year={2017},
  publisher={Routledge: Taylor & Francis Group},
  volume={27},
  doi={10.1080/08993408.2017.1315958},
  url={https://doi.org/10.1080/08993408.2017.1315958}
}

@article{immediateFeedback,
  title={Immediate Feedback during Academic Testing},
  author={Epstein, Michael L. and Epstein, Beth B. and Brosvic, Gary M.},
  year={2001},
  volume={88},
  pages={889-894},
  doi={10.2466/pr0.2001.88.3.889},
  url={https://doi-org.ezproxy.lib.gla.ac.uk/10.2466/pr0.2001.88.3.889}
}

@MISC{suspercentiles,
  title={Measuring Usability with the System Usability Scale (SUS)},
  author={Sauro, Jeff},
  year={2011},
  howpublished={\url{https://measuringu.com/sus/}}
}

@MISC{susquestionnaire,
  title={System Usability Scale (SUS) Plus},
  author={usabiliTEST},
  accessed={31/03/2020},
  howpublished={\url{https://www.usabilitest.com/system-usability-scale}}
}